class compiler {
  constructor(Vue) {
    this.Vue = Vue
    this.html = ''
    this.js = ''
    this.css = ''
    this.program = null
  }
  getSource (source, type) {
    const regex = new RegExp(`<${type}[^>]*>`);
    let openingTag = source.match(regex);
    if (!openingTag) return '';
    else openingTag = openingTag[0];
    return source.slice(
      source.indexOf(openingTag) + openingTag.length,
      source.lastIndexOf(`</${type}>`)
    );
  }
  splitCode (code) {
    const script = this.getSource(code, 'script').replace(
      /export default/,
      'return '
    );
    const style = this.getSource(code, 'style');
    const template =
      `<div>${
        this.getSource(code, 'template')
      }</div>`;
    this.js = script;
    this.css = style;
    this.html = template;
    if (this.html === '' || this.js === '') {
      return '请输入有效的Vue代码'
    }
  }
  mount (el) {
    // eslint-disable-next-line no-new-func
    const container = document.getElementById(el)
    if (!container) return
    this.unmount(el)
    const common = new Function(this.js)();
    common.template = this.html;
    const Template = this.Vue.extend(common);
    this.program = new Template();
    document.getElementById(el).appendChild(this.program.$mount().$el);
    // this.program.$mount('#' + el)
    if (this.css !== '') {
      const styles = document.createElement('style');
      styles.type = 'text/css';
      styles.dataset.blockName = el
      styles.innerHTML = this.css;
      document.getElementsByTagName('head')[0].appendChild(styles);
    }
  }
  unmount (el) {
    const container = document.getElementById(el)
    container && (container.innerHTML = '')
    const styleContainer = document.querySelector(`[data-block-name=${el}]`)
    styleContainer && styleContainer.remove()
    if (this.program) {
      this.program.$destroy();
      this.program = null;
    }
  }
}

export default compiler
